/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import com.iceberg.*;
import javax.microedition.lcdui.*;




/**
 * @author DDDEN!SSS
 */
public class MyCanvas extends Canvas implements Runnable {
    private final Matrix matrixLight = new Matrix();
    private final Matrix matrixFigure = new Matrix();
    private final Matrix matrixTemp = new Matrix();
    
    private final Figure figure = new Figure(Main.main.getFile("/res/3D.txt"));
    
    private int key;
    private Thread thread;
    private boolean running;
    private int mode = 0; //0-rotation 1-move
    private final String[] modes = {"Rot","Move","Light"}; 
    
    private static final Font font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
    
    public MyCanvas() {
        setFullScreenMode(true);
        G3D.setCentre(getWidth()/2, getHeight()/2);
        matrixFigure.t23=600;
        setFigure(null);
    }

    public void threadStart() {
        thread = new Thread(this);
        running = true;
        thread.start();
    }

    public void paint(Graphics g) {
        g.setColor(0xeeeeee);
        g.fillRect(0, 0, Main.width, Main.height);
        g.setFont(font);
        
        G3D.removeAll();
        G3D.addFigure(figure);
        G3D.render(g);
        
        
        g.setColor(0x000000);
        g.drawString(" "+modes[mode], 0, 0, 0);
        g.drawString("fps "+Fps.fps(), Main.width-50, 0, 0);
    }

    protected void keyPressed(int k) {
        key = k;
        if(k == 53) {
            mode++;
            if(mode>2) {
                mode=0;
            }
        }
    }

    protected void keyReleased(int k) {
        key = 0;
    }
    
    private void rotLight(int k) {
        switch (k) {
            case 52 : matrixTemp.rotationY(5); matrixLight.mul(matrixTemp); break;
            case 54 : matrixTemp.rotationY(-5); matrixLight.mul(matrixTemp); break;
            
            case 50 :  matrixTemp.rotationX(5); matrixLight.mul(matrixTemp); break;
            case 56 :  matrixTemp.rotationX(-5); matrixLight.mul(matrixTemp); break;
            
            case 49 :  matrixTemp.rotationZ(5); matrixLight.mul(matrixTemp); break;
            case 51 :  matrixTemp.rotationZ(-5); matrixLight.mul(matrixTemp); break;
        }
        Light.setMatrix(matrixLight);
        setFigure(null);
    }
    
    private void rotFigure(int k) {
        switch (k) {
            case 52 : rotY(5); break;
            case 54 : rotY(-5); break;
            
            case 50 : rotX(5); break;
            case 56 : rotX(-5); break;
            
            case 49 : rotZ(5); break;
            case 51 : rotZ(-5); break;
        }
    }
    public void rotX(int i) {
        matrixTemp.rotationX(i);
        setFigure(matrixTemp);
    }
    public void rotY(int i) {
        matrixTemp.rotationY(i);
        setFigure(matrixTemp);
    }
    public void rotZ(int i) {
        matrixTemp.rotationZ(i);
        setFigure(matrixTemp);
    }
    private void setFigure(Matrix m) {
        if(m != null) {
            matrixFigure.mul(m);
        } else {
            matrixFigure.toFP();
        }
        figure.setMatrix(matrixFigure);
    }
    
    private void moveFigure(int k) {
        switch (k) {
            case 52 : matrixFigure.t03-=15; setFigure(null); break;
            case 54 : matrixFigure.t03+=15; setFigure(null); break;
            
            case 50 : matrixFigure.t13-=15; setFigure(null); break;
            case 56 : matrixFigure.t13+=15; setFigure(null); break;
            
            case 49 : matrixFigure.t23+=15; setFigure(null); break;
            case 51 : matrixFigure.t23-=15; setFigure(null); break;
        }
    }
    

    public void run() {
        while (running) {
            if(mode == 0) {
                rotFigure(key);
            }
            if(mode == 1) {
                moveFigure(key);
            }
            if(mode == 2) {
                rotLight(key);
            }
            
            
            if(key==42) {
                G3D.persY-=2;
                setFigure(null);
            }
            if(key==35) {
                G3D.persY+=2;
                setFigure(null);
            }
            repaint();
            
            try {
                Thread.sleep(1L);
            } catch (Exception ex) {ex.printStackTrace();}
        }
    }
}