package com.iceberg;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.util.Vector;
import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public class Figure { //класс содержащий стандартную 3D модель
    public Vertex[] vertexs; //вершинывершины
    public Element3D[] elements; // 3D элементы
    
    
    
    
    public Figure(byte[] b) {
        Creator.create(b, this);
    }
    
    
    
    public void setMatrix(Matrix m) { // поворачиваем вершины
        for (int i=vertexs.length-1; i >= 0; i--) {
            vertexs[i].setMatrix(m);
        }
        for(int i=elements.length-1; i>=0; i--) {
            elements[i].setMatrix(m);
        }
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private static class Creator {
        private static final String vertexStr = "Vertex(";
        private static final String colorStr = "Color(";
        private static final String polygon3VStr = "Polygon3V(";
        private static final String polygon4VStr = "Polygon4V(";
        
        
        public static void create(byte[] b, Figure f) {
            String model = new String(b);
            loadVertex(model, f);
            loadEments(model, f);
            
            System.out.println("вершин: "+f.vertexs.length);
            System.out.println("полигонов: "+f.elements.length);
        }
        
        private static void loadVertex(String m, Figure f) { //загружаем вершины
            int v1 = m.indexOf(vertexStr, 0);
            int v2 = m.indexOf(")", v1);
            String vertex = m.substring(v1+vertexStr.length(), v2);
            
            f.vertexs = new Vertex[r(vertex, ";")];
            int i1 = 0;
            int i2 = -1;
            for(int i=0; i<f.vertexs.length; i++) {
                i1 = vertex.indexOf(';', i2+1);
                String v = vertex.substring(i2+1, i1);
                f.vertexs[i] = new Vertex(v);
                i2 = i1;
            }
        }
        
        private static int[] loadColor(String m) {
            int p1 = m.indexOf(colorStr, 0);
            int p2 = m.indexOf(")", p1);
            String color = m.substring(p1+colorStr.length(), p2);
            
            int[] col = new int[r(color, ";")];
            
            int i1 = 0;
            int i2 = -1;
            for(int i=0; i<col.length; i++) { //загружаем полигоны
                i1 = color.indexOf(';', i2+1);
                String p = color.substring(i2+1, i1);
                col[i] = Integer.parseInt(p);
                i2 = i1;
            }
            return col;
        }
        
        private static void loadEments(String m, Figure f) { //загружаем 3Д елементы
            int[] colors = loadColor(m);
            
            Vector el = new Vector(); //вектор для хранения элементов
            
            int p1 = m.indexOf(polygon3VStr, 0);
            int p2 = m.indexOf(")", p1);
            String polygon3V = m.substring(p1+polygon3VStr.length(), p2); //строка с полигонами3V
            
            int polygons3V = r(polygon3V, ";"); //сколько полигонов
            
            int i1 = 0;
            int i2 = -1;
            for(int i=0; i<polygons3V; i++) { //загружаем полигоны
                i1 = polygon3V.indexOf(';', i2+1);
                String p = polygon3V.substring(i2+1, i1);
                Polygon3V v3 = new Polygon3V(p, f.vertexs, colors);
                el.addElement(v3);
                i2 = i1;
            }
            
            
            p1 = m.indexOf(polygon4VStr, 0);
            p2 = m.indexOf(")", p1);
            String polygon4V = m.substring(p1+polygon4VStr.length(), p2); //строка с полигонами4V
            
            int polygons4V = r(polygon4V, ";"); //сколько полигонов
            
            i1 = 0;
            i2 = -1;
            for(int i=0; i<polygons4V; i++) { //загружаем полигоны
                i1 = polygon4V.indexOf(';', i2+1);
                String p = polygon4V.substring(i2+1, i1);
                Polygon4V v4 = new Polygon4V(p, f.vertexs, colors);
                el.addElement(v4);
                i2 = i1;
            }
            
            f.elements = new Element3D[el.size()];
            for(int i=0; i<el.size(); i++) {
                f.elements[i] = (Element3D)el.elementAt(i);
            }
        }
        
        
        
        private static int r(String i, String r) { //сколько символов r в строке i
            int rr=0;
            int i1 = 0;
            int i2 = -1;
            while(true) {
                i1 = i.indexOf(r, i2 + 1);
                if(i1==-1) {
                    break;
                }
                rr++;
                i2 = i1;
            }
            return rr;
        }
        
        
    }
    
    
    
    
    
    
    
    
    
    
}
