/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.iceberg;

import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public class Normal {
    public static final int fp = 4096;
    private short nxReal, nyReal, nzReal;
    public int nx, ny, nz;
    
    public Normal(Polygon3V p3v) {
        Vertex v1 = p3v.v3;
        Vertex v2 = p3v.v2;
        Vertex v3 = p3v.v1;
        
        float tnx = ( (v1.yReal-v2.yReal)*(v1.zReal-v3.zReal) ) - ( (v1.zReal-v2.zReal)*(v1.yReal-v3.yReal) );
        float tny = ( (v1.zReal-v2.zReal)*(v1.xReal-v3.xReal) ) - ( (v1.xReal-v2.xReal)*(v1.zReal-v3.zReal) );
        float tnz = ( (v1.xReal-v2.xReal)*(v1.yReal-v3.yReal) ) - ( (v1.yReal-v2.yReal)*(v1.xReal-v3.xReal) );
        float length = (float)Math.sqrt( tnx*tnx+tny*tny+tnz*tnz );
        tnx /= length;
        tny /= length;
        tnz /= length;
        nx = nxReal = (short)(tnx*fp);
        ny = nyReal = (short)(tny*fp);
        nz = nzReal = (short)(tnz*fp);
    }
    
    public Normal(Polygon4V p4v) {
        Vertex v1 = p4v.v4;
        Vertex v2 = p4v.v2;
        Vertex v3 = p4v.v1;
        
        float tx1 = ( (v1.yReal-v2.yReal)*(v1.zReal-v3.zReal) ) - ( (v1.zReal-v2.zReal)*(v1.yReal-v3.yReal) );
        float ty1 = ( (v1.zReal-v2.zReal)*(v1.xReal-v3.xReal) ) - ( (v1.xReal-v2.xReal)*(v1.zReal-v3.zReal) );
        float tz1 = ( (v1.xReal-v2.xReal)*(v1.yReal-v3.yReal) ) - ( (v1.yReal-v2.yReal)*(v1.xReal-v3.xReal) );
        
        float length = (float)Math.sqrt( tx1*tx1+ty1*ty1+tz1*tz1 );
        
        tx1 = tx1/length;
        ty1 = ty1/length;
        tz1 = tz1/length;
        
        
        v1 = p4v.v4;
        v2 = p4v.v3;
        v3 = p4v.v2;
        
        float tx2 = ( (v1.yReal-v2.yReal)*(v1.zReal-v3.zReal) ) - ( (v1.zReal-v2.zReal)*(v1.yReal-v3.yReal) );
        float ty2 = ( (v1.zReal-v2.zReal)*(v1.xReal-v3.xReal) ) - ( (v1.xReal-v2.xReal)*(v1.zReal-v3.zReal) );
        float tz2 = ( (v1.xReal-v2.xReal)*(v1.yReal-v3.yReal) ) - ( (v1.yReal-v2.yReal)*(v1.xReal-v3.xReal) );
        
        length = (float)Math.sqrt( tx2*tx2+ty2*ty2+tz2*tz2 );
        
        tx2 = tx2/length;
        ty2 = ty2/length;
        tz2 = tz2/length;
        
        
        
        nx = nxReal = (short)((tx1+tx2)/2*fp);
        ny = nyReal = (short)((ty1+ty2)/2*fp);
        nz = nzReal = (short)((tz1+tz2)/2*fp);
    }
    
    
    
    public final void setMatrix(Matrix m) {
        nx = (nxReal*m.m00 + nyReal*m.m01 + nzReal*m.m02)>>12; //умножаем вершину на все вектора матрицы
        ny = (nxReal*m.m10 + nyReal*m.m11 + nzReal*m.m12)>>12;
        nz = (nxReal*m.m20 + nyReal*m.m21 + nzReal*m.m22)>>12;
    }
    
    
    
    
    
    
    

}