package com.iceberg;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import com.iceberg.*;
import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public class Polygon4V implements Element3D {
    private boolean visible; //если виден
    
    public Vertex v1, v2, v3, v4;
    private int colorReal;
    private int color;
    private int sz; //z средняя
    
    private Normal normal;
    
    public Polygon4V(String pol, Vertex[] ver, int[] colors) {
        int t1 = pol.indexOf(",", 0);
        int t2 = pol.indexOf(",", t1+1);
        int t3 = pol.indexOf(",", t2+1);
        int t4 = pol.indexOf(",", t3+1);
        
        String v1Str = pol.substring(0, t1);
        String v2Str = pol.substring(t1+1, t2);
        String v3Str = pol.substring(t2+1, t3);
        String v4Str = pol.substring(t3+1, t4);
        
        String colorStr = pol.substring(t4+1, pol.length());
        
        v1 = ver[Integer.parseInt(v1Str)];
        v2 = ver[Integer.parseInt(v2Str)];
        v3 = ver[Integer.parseInt(v3Str)];
        v4 = ver[Integer.parseInt(v4Str)];
        
        int col = Integer.parseInt(colorStr);
        color = colorReal = colors[col];
        
        normal = new Normal(this);
    }
    
    
    
    
    public final void paint(Graphics g) {
        g.setColor(color);
        g.fillTriangle(v1.sx, v1.sy, v2.sx, v2.sy, v4.sx, v4.sy);
        g.fillTriangle(v2.sx, v2.sy, v3.sx, v3.sy, v4.sx, v4.sy);
        // 3              4
        // |--------------|
        // |------------/-|
        // |----------/---|
        // |--------/-----|
        // |------/-------|
        // |----/---------|
        // |--/-----------|
        // |/-------------|
        // 2              1
    }
    
    public final void setMatrix(Matrix m) { //средняя Z координата
        sz = (v1.z+v2.z+v3.z+v4.z) >> 2;
        normal.setMatrix(m);
        visible();
        if(visible) {
            color = Light.color(colorReal, normal);
        }
    }
    public final int getSz() {
        return sz;
    }
    
    private final void visible() { //определить виден или нет
        if(sz>0 && sz<G3D.range && normal.nz<0) {
            visible = true;
        } else {
            visible = false;
        }
    }
    public final boolean ifVisible() {
        return visible;
    }
    
    
    

}